/**
 * 
 */
package ui.view;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;

import javax.swing.ImageIcon;
import javax.swing.JPanel;

import classes.HolonObject;
import classes.SubNet;
import ui.controller.Control;
import ui.model.Model;

/**
 * This class shows the holon view
 * 
 * @author Gruppe14
 *
 */
public class HolonCanvas extends JPanel {
	private static final long serialVersionUID = 1L;
	// edge Object Start Point
	private Model model;
	private final Control controller;
	Graphics2D g2; // For Painting

	/**
	 * Constructor.
	 * 
	 * @param mod
	 *            the Model
	 * @param control
	 *            the Controller
	 */
	public HolonCanvas(Model mod, Control control) {
		this.controller = control;
		this.model = mod;
	}

	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		// Rendering
		g2 = (Graphics2D) g;
		RenderingHints rh = new RenderingHints(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setRenderingHints(rh);

		int i = 0;
		int k = 0;
		// Objects
		for (SubNet s : controller.getSimManager().getSubNets()) {
			// draw image
			g2.setColor(model.getSubNetColors().get(k));
			g2.fillOval(10 + i, 10 + i, controller.getScale() * s.getObjects().size() / 4,
					controller.getScale() * s.getObjects().size() / 4);
			k += 1;
			i += 20;
		}
	}
}
